Index: group__wireless.html
===================================================================
--- group__wireless.html	(revision 736)
+++ group__wireless.html	(revision 737)
@@ -22,9 +22,9 @@
 <tr><td class="memItemLeft" nowrap align="right" valign="top">struct &nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a></td></tr>
 
 <tr><td colspan="2"><br><h2>Functions</h2></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g629ceefdf83847af356d90e2df27041c">wl_init</a> (void)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gedd4562415e273ce6537f9c1a0f2701b">wl_init</a> (void)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the wireless library.  <a href="#g629ceefdf83847af356d90e2df27041c"></a><br></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Initialize the wireless library.  <a href="#gedd4562415e273ce6537f9c1a0f2701b"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g66075ff87a1c9f2c0d7938a26c7830f2">wl_terminate</a> (void)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Uninitialize the wireless library.  <a href="#g66075ff87a1c9f2c0d7938a26c7830f2"></a><br></td></tr>
@@ -37,33 +37,33 @@
 <tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gcdbedf6465798abc7af3bf5fea3d4dd7">wl_unregister_packet_group</a> (<a class="el" href="structPacketGroupHandler.html">PacketGroupHandler</a> *h)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Unregister a packet group with the wireless library.  <a href="#gcdbedf6465798abc7af3bf5fea3d4dd7"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#ga7175b13dbfc0b11b341fbe0ad7c637c">wl_send_robot_to_robot_global_packet</a> (char group, char type, char *data, int len, int dest, char frame)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g6e841a6ef0504538d8650a0a2f5fa869">wl_send_robot_to_robot_global_packet</a> (char group, char type, char *data, int len, int dest, char frame)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to a specific robot in any PAN.  <a href="#ga7175b13dbfc0b11b341fbe0ad7c637c"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gafaca74445d215cef2b2e0ae1a1c72ba">wl_send_robot_to_robot_packet</a> (char group, char type, char *data, int len, int dest, char frame)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to a specific robot in any PAN.  <a href="#g6e841a6ef0504538d8650a0a2f5fa869"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gf8fbadf62eeb754b98b200328fb7a8be">wl_send_robot_to_robot_packet</a> (char group, char type, char *data, int len, int dest, char frame)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to a specific robot in our PAN.  <a href="#gafaca74445d215cef2b2e0ae1a1c72ba"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gdd534c99c49d5207fe09f02af304c1ad">wl_send_global_packet</a> (char group, char type, char *data, int len, char frame)</td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to a specific robot in our PAN.  <a href="#gf8fbadf62eeb754b98b200328fb7a8be"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#gda6b187ea58cee5aec18725bf7f24b9a">wl_send_global_packet</a> (char group, char type, char *data, int len, char frame)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to all robots.  <a href="#gdd534c99c49d5207fe09f02af304c1ad"></a><br></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to all robots.  <a href="#gda6b187ea58cee5aec18725bf7f24b9a"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g0a1a0e4d885f0e0dde87160a16daa0aa">wl_send_pan_packet</a> (char group, char type, char *data, int len, char frame)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Send a packet to all robots in our PAN.  <a href="#g0a1a0e4d885f0e0dde87160a16daa0aa"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g211ccf907dce4493813573e20264e542">wl_set_pan</a> (int pan)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g754445d2353a70963a489651cff554c1">wl_set_pan</a> (int pan)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the PAN we are using.  <a href="#g211ccf907dce4493813573e20264e542"></a><br></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the PAN we are using.  <a href="#g754445d2353a70963a489651cff554c1"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g4e6b5c97d40a8e7557a1b4b90a7d34f7">wl_get_pan</a> (void)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the PAN we are using.  <a href="#g4e6b5c97d40a8e7557a1b4b90a7d34f7"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g9aac809e57c9eb93a2905ed544c93aba">wl_set_channel</a> (int channel)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g51d3fe958d44fd92f0e0830ced13139d">wl_set_channel</a> (int channel)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the channel we are using.  <a href="#g9aac809e57c9eb93a2905ed544c93aba"></a><br></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the channel we are using.  <a href="#g51d3fe958d44fd92f0e0830ced13139d"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g2d65d3e35b193da4213755c4bf61ab6b">wl_get_channel</a> (void)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the channel we are using.  <a href="#g2d65d3e35b193da4213755c4bf61ab6b"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">unsigned int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g90cb41c855ac3da028e8f1278bd49f4f">wl_get_xbee_id</a> (void)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g6c75a84ff5f9a2bdc156aba522d2adf7">wl_get_xbee_id</a> (void)</td></tr>
 
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the 16-bit address of the XBee module.  <a href="#g90cb41c855ac3da028e8f1278bd49f4f"></a><br></td></tr>
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the 16-bit address of the XBee module.  <a href="#g6c75a84ff5f9a2bdc156aba522d2adf7"></a><br></td></tr>
 <tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="g344dead0023100eb40f8670a92c9ce5c"></a><!-- doxytag: member="wireless::wl_set_com_port" ref="g344dead0023100eb40f8670a92c9ce5c" args="(char *port)" -->
 void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__wireless.html#g344dead0023100eb40f8670a92c9ce5c">wl_set_com_port</a> (char *port)</td></tr>
 
@@ -122,7 +122,7 @@
 <p>
 Get the channel the XBee is part of.<p>
 <dl class="return" compact><dt><b>Returns:</b></dt><dd>the channel the XBee is part of</dd></dl>
-<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wireless.html#g9aac809e57c9eb93a2905ed544c93aba" title="Set the channel we are using.">wl_set_channel</a> </dd></dl>
+<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wireless.html#g51d3fe958d44fd92f0e0830ced13139d" title="Set the channel we are using.">wl_set_channel</a> </dd></dl>
 
 </div>
 </div><p>
@@ -147,16 +147,16 @@
 <p>
 Get the PAN the XBee is currently part of.<p>
 <dl class="return" compact><dt><b>Returns:</b></dt><dd>the PAN of the XBee</dd></dl>
-<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wireless.html#g211ccf907dce4493813573e20264e542" title="Set the PAN we are using.">wl_set_pan</a> </dd></dl>
+<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="group__wireless.html#g754445d2353a70963a489651cff554c1" title="Set the PAN we are using.">wl_set_pan</a> </dd></dl>
 
 </div>
 </div><p>
-<a class="anchor" name="g90cb41c855ac3da028e8f1278bd49f4f"></a><!-- doxytag: member="wireless.h::wl_get_xbee_id" ref="g90cb41c855ac3da028e8f1278bd49f4f" args="(void)" -->
+<a class="anchor" name="g6c75a84ff5f9a2bdc156aba522d2adf7"></a><!-- doxytag: member="wireless.h::wl_get_xbee_id" ref="g6c75a84ff5f9a2bdc156aba522d2adf7" args="(void)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">unsigned int wl_get_xbee_id           </td>
+          <td class="memname">int wl_get_xbee_id           </td>
           <td>(</td>
           <td class="paramtype">void&nbsp;</td>
           <td class="paramname">          </td>
@@ -175,12 +175,12 @@
 
 </div>
 </div><p>
-<a class="anchor" name="g629ceefdf83847af356d90e2df27041c"></a><!-- doxytag: member="wireless.h::wl_init" ref="g629ceefdf83847af356d90e2df27041c" args="(void)" -->
+<a class="anchor" name="gedd4562415e273ce6537f9c1a0f2701b"></a><!-- doxytag: member="wireless.h::wl_init" ref="gedd4562415e273ce6537f9c1a0f2701b" args="(void)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_init           </td>
+          <td class="memname">int wl_init           </td>
           <td>(</td>
           <td class="paramtype">void&nbsp;</td>
           <td class="paramname">          </td>
@@ -194,7 +194,13 @@
 <p>
 Initialize the wireless library. 
 <p>
-Initializes the wireless library. Must be called before any other function. 
+Initializes the wireless library. Must be called before any other function.<p>
+<dl compact><dt><b>Parameters:</b></dt><dd>
+  <table border="0" cellspacing="2" cellpadding="0">
+    <tr><td valign="top"></td><td valign="top"><em>wl_port</em>&nbsp;</td><td>File descriptor for wireless port, or NULL for default. </td></tr>
+  </table>
+</dl>
+
 </div>
 </div><p>
 <a class="anchor" name="g183343ed0594ec1c2b79bb4085d57107"></a><!-- doxytag: member="wireless.h::wl_register_packet_group" ref="g183343ed0594ec1c2b79bb4085d57107" args="(PacketGroupHandler *h)" -->
@@ -225,12 +231,12 @@
 
 </div>
 </div><p>
-<a class="anchor" name="gdd534c99c49d5207fe09f02af304c1ad"></a><!-- doxytag: member="wireless.h::wl_send_global_packet" ref="gdd534c99c49d5207fe09f02af304c1ad" args="(char group, char type, char *data, int len, char frame)" -->
+<a class="anchor" name="gda6b187ea58cee5aec18725bf7f24b9a"></a><!-- doxytag: member="wireless.h::wl_send_global_packet" ref="gda6b187ea58cee5aec18725bf7f24b9a" args="(char group, char type, char *data, int len, char frame)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_send_global_packet           </td>
+          <td class="memname">int wl_send_global_packet           </td>
           <td>(</td>
           <td class="paramtype">char&nbsp;</td>
           <td class="paramname"> <em>group</em>, </td>
@@ -343,12 +349,12 @@
 
 </div>
 </div><p>
-<a class="anchor" name="ga7175b13dbfc0b11b341fbe0ad7c637c"></a><!-- doxytag: member="wireless.h::wl_send_robot_to_robot_global_packet" ref="ga7175b13dbfc0b11b341fbe0ad7c637c" args="(char group, char type, char *data, int len, int dest, char frame)" -->
+<a class="anchor" name="g6e841a6ef0504538d8650a0a2f5fa869"></a><!-- doxytag: member="wireless.h::wl_send_robot_to_robot_global_packet" ref="g6e841a6ef0504538d8650a0a2f5fa869" args="(char group, char type, char *data, int len, int dest, char frame)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_send_robot_to_robot_global_packet           </td>
+          <td class="memname">int wl_send_robot_to_robot_global_packet           </td>
           <td>(</td>
           <td class="paramtype">char&nbsp;</td>
           <td class="paramname"> <em>group</em>, </td>
@@ -409,12 +415,12 @@
 
 </div>
 </div><p>
-<a class="anchor" name="gafaca74445d215cef2b2e0ae1a1c72ba"></a><!-- doxytag: member="wireless.h::wl_send_robot_to_robot_packet" ref="gafaca74445d215cef2b2e0ae1a1c72ba" args="(char group, char type, char *data, int len, int dest, char frame)" -->
+<a class="anchor" name="gf8fbadf62eeb754b98b200328fb7a8be"></a><!-- doxytag: member="wireless.h::wl_send_robot_to_robot_packet" ref="gf8fbadf62eeb754b98b200328fb7a8be" args="(char group, char type, char *data, int len, int dest, char frame)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_send_robot_to_robot_packet           </td>
+          <td class="memname">int wl_send_robot_to_robot_packet           </td>
           <td>(</td>
           <td class="paramtype">char&nbsp;</td>
           <td class="paramname"> <em>group</em>, </td>
@@ -475,12 +481,12 @@
 
 </div>
 </div><p>
-<a class="anchor" name="g9aac809e57c9eb93a2905ed544c93aba"></a><!-- doxytag: member="wireless.h::wl_set_channel" ref="g9aac809e57c9eb93a2905ed544c93aba" args="(int channel)" -->
+<a class="anchor" name="g51d3fe958d44fd92f0e0830ced13139d"></a><!-- doxytag: member="wireless.h::wl_set_channel" ref="g51d3fe958d44fd92f0e0830ced13139d" args="(int channel)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_set_channel           </td>
+          <td class="memname">int wl_set_channel           </td>
           <td>(</td>
           <td class="paramtype">int&nbsp;</td>
           <td class="paramname"> <em>channel</em>          </td>
@@ -504,12 +510,12 @@
 
 </div>
 </div><p>
-<a class="anchor" name="g211ccf907dce4493813573e20264e542"></a><!-- doxytag: member="wireless.h::wl_set_pan" ref="g211ccf907dce4493813573e20264e542" args="(int pan)" -->
+<a class="anchor" name="g754445d2353a70963a489651cff554c1"></a><!-- doxytag: member="wireless.h::wl_set_pan" ref="g754445d2353a70963a489651cff554c1" args="(int pan)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">void wl_set_pan           </td>
+          <td class="memname">int wl_set_pan           </td>
           <td>(</td>
           <td class="paramtype">int&nbsp;</td>
           <td class="paramname"> <em>pan</em>          </td>
@@ -583,7 +589,7 @@
 
 </div>
 </div><p>
-<hr size="1"><address style="text-align: right;"><small>Generated on Thu Nov 8 23:27:23 2007 for libwireless by&nbsp;
+<hr size="1"><address style="text-align: right;"><small>Generated on Mon Apr 28 17:49:53 2008 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.3 </small></address>
 </body>