Index: wl__token__ring_8h-source.html
===================================================================
--- wl__token__ring_8h-source.html	(revision 736)
+++ wl__token__ring_8h-source.html	(revision 737)
@@ -17,12 +17,12 @@
 <a name="l00035"></a>00035 <span class="preprocessor">#ifndef WL_TOKEN_RING_H</span>
 <a name="l00036"></a>00036 <span class="preprocessor"></span><span class="preprocessor">#define WL_TOKEN_RING_H</span>
 <a name="l00037"></a>00037 <span class="preprocessor"></span>
-<a name="l00050"></a>00050 <span class="keywordtype">void</span> <a class="code" href="group__tokenring.html#g7bfd97ec1f89b442b278bbcddc6b6ee1" title="Register the token ring group with the wireless library.">wl_token_ring_register</a>(<span class="keywordtype">void</span>);
+<a name="l00050"></a>00050 <span class="keywordtype">int</span> <a class="code" href="group__tokenring.html#g00fb5cca21a50d39aa1e82fdc679ca44" title="Register the token ring group with the wireless library.">wl_token_ring_register</a>(<span class="keywordtype">void</span>);
 <a name="l00052"></a>00052 <span class="keywordtype">void</span> <a class="code" href="group__tokenring.html#gde3dd682b6a757bab6ce4cbc9c518f8e" title="Unregister the token ring group with the wirelss library.">wl_token_ring_unregister</a>(<span class="keywordtype">void</span>);
-<a name="l00054"></a>00054 <span class="keywordtype">void</span> <a class="code" href="group__tokenring.html#g0c407d5c215a97d58c67006bcc6e53ce" title="Set the functions called to turn the bom on and off.">wl_token_ring_set_bom_functions</a>(<span class="keywordtype">void</span> (*on_function) (<span class="keywordtype">void</span>), 
-<a name="l00055"></a>00055                 <span class="keywordtype">void</span> (*off_function) (<span class="keywordtype">void</span>), <span class="keywordtype">int</span> (*max_bom_function) (<span class="keywordtype">void</span>));
+<a name="l00054"></a>00054 <span class="keywordtype">void</span> <a class="code" href="group__tokenring.html#g0c407d5c215a97d58c67006bcc6e53ce" title="Set the functions called to turn the bom on and off.">wl_token_ring_set_bom_functions</a>(<span class="keywordtype">void</span> (*on_function) (<span class="keywordtype">void</span>), <span class="keywordtype">void</span> (*off_function) (<span class="keywordtype">void</span>),
+<a name="l00055"></a>00055   <span class="keywordtype">int</span> (*max_bom_function) (<span class="keywordtype">void</span>));
 <a name="l00056"></a>00056 
-<a name="l00058"></a>00058 <span class="keywordtype">void</span> <a class="code" href="group__tokenring.html#gbdb1e2258d1c69086692d2d31e02fb27" title="Join the token ring.">wl_token_ring_join</a>(<span class="keywordtype">void</span>);
+<a name="l00058"></a>00058 <span class="keywordtype">int</span> <a class="code" href="group__tokenring.html#ge1012b6d6c1c46b26a6c6da7e4ec7c88" title="Join the token ring.">wl_token_ring_join</a>(<span class="keywordtype">void</span>);
 <a name="l00060"></a>00060 <span class="keywordtype">void</span> <a class="code" href="group__tokenring.html#g6c2dd8742e100f63d4fb002707d1e85a" title="Leave the token ring.">wl_token_ring_leave</a>(<span class="keywordtype">void</span>);
 <a name="l00061"></a>00061 
 <a name="l00063"></a>00063 <span class="keywordtype">int</span> <a class="code" href="group__tokenring.html#g0c61bb8892aa5513706e00cd8ce5ca8b" title="Return the number of robots in the token ring.">wl_token_get_robots_in_ring</a>(<span class="keywordtype">void</span>);
@@ -39,7 +39,7 @@
 <a name="l00082"></a>00082  <span class="comment">//end token ring group</span>
 <a name="l00084"></a>00084 
 <a name="l00085"></a>00085 <span class="preprocessor">#endif</span>
-</pre></div><hr size="1"><address style="text-align: right;"><small>Generated on Thu Nov 8 23:27:22 2007 for libwireless by&nbsp;
+</pre></div><hr size="1"><address style="text-align: right;"><small>Generated on Mon Apr 28 17:49:53 2008 for libwireless by&nbsp;
 <a href="http://www.doxygen.org/index.html">
 <img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.3 </small></address>
 </body>