commit a767a322b1a4a2ea05b88f83d8e04958ed2dd8a6
Author: Julian Binder <jabinder@andrew.cmu.edu>
Date:   Fri Nov 30 16:47:23 2012 -0500

    added tx/rx breakout for avr to gumstix serial connection

diff --git a/scoutfly/scoutfly_rev3.brd b/scoutfly/scoutfly_rev3.brd
index 47b16be..baebc62 100755
--- a/scoutfly/scoutfly_rev3.brd
+++ b/scoutfly/scoutfly_rev3.brd
@@ -192,6 +192,9 @@
 <text x="44.958" y="0.508" size="1.27" layer="21" font="vector" ratio="15">bwasserm</text>
 <text x="62.865" y="3.81" size="1.27" layer="21" font="vector" ratio="15">kwoo</text>
 <text x="32.004" y="70.612" size="1.27" layer="21">PWR ON</text>
+<text x="95.25" y="3.937" size="0.6096" layer="21" rot="R90">GND</text>
+<text x="95.123" y="7.493" size="0.6096" layer="21" rot="R90">TX</text>
+<text x="94.742" y="10.922" size="0.6096" layer="21" rot="R90">RX</text>
 </plain>
 <libraries>
 <library name="kwoo">
@@ -1914,6 +1917,48 @@ chip</description>
 </package>
 </packages>
 </library>
+<library name="con-lstb">
+<description>&lt;b&gt;Pin Headers&lt;/b&gt;&lt;p&gt;
+Naming:&lt;p&gt;
+MA = male&lt;p&gt;
+# contacts - # rows&lt;p&gt;
+W = angled&lt;p&gt;
+&lt;author&gt;Created by librarian@cadsoft.de&lt;/author&gt;</description>
+<packages>
+<package name="MA03-1">
+<description>&lt;b&gt;PIN HEADER&lt;/b&gt;</description>
+<wire x1="-3.175" y1="1.27" x2="-1.905" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="-1.905" y1="1.27" x2="-1.27" y2="0.635" width="0.1524" layer="21"/>
+<wire x1="-1.27" y1="-0.635" x2="-1.905" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="-1.27" y1="0.635" x2="-0.635" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="-0.635" y1="1.27" x2="0.635" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="0.635" y1="1.27" x2="1.27" y2="0.635" width="0.1524" layer="21"/>
+<wire x1="1.27" y1="-0.635" x2="0.635" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="0.635" y1="-1.27" x2="-0.635" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="-0.635" y1="-1.27" x2="-1.27" y2="-0.635" width="0.1524" layer="21"/>
+<wire x1="-3.81" y1="0.635" x2="-3.81" y2="-0.635" width="0.1524" layer="21"/>
+<wire x1="-3.175" y1="1.27" x2="-3.81" y2="0.635" width="0.1524" layer="21"/>
+<wire x1="-3.81" y1="-0.635" x2="-3.175" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="-1.905" y1="-1.27" x2="-3.175" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="1.27" y1="0.635" x2="1.905" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="1.905" y1="1.27" x2="3.175" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="3.175" y1="1.27" x2="3.81" y2="0.635" width="0.1524" layer="21"/>
+<wire x1="3.81" y1="-0.635" x2="3.175" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="3.175" y1="-1.27" x2="1.905" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="1.905" y1="-1.27" x2="1.27" y2="-0.635" width="0.1524" layer="21"/>
+<wire x1="3.81" y1="0.635" x2="3.81" y2="-0.635" width="0.1524" layer="21"/>
+<pad name="1" x="-2.54" y="0" drill="1.016" shape="long" rot="R90"/>
+<pad name="2" x="0" y="0" drill="1.016" shape="long" rot="R90"/>
+<pad name="3" x="2.54" y="0" drill="1.016" shape="long" rot="R90"/>
+<text x="-3.81" y="1.651" size="1.27" layer="25" ratio="10">&gt;NAME</text>
+<text x="-5.08" y="-0.635" size="1.27" layer="21" ratio="10">1</text>
+<text x="-3.81" y="-2.921" size="1.27" layer="27" ratio="10">&gt;VALUE</text>
+<rectangle x1="-0.254" y1="-0.254" x2="0.254" y2="0.254" layer="51"/>
+<rectangle x1="-2.794" y1="-0.254" x2="-2.286" y2="0.254" layer="51"/>
+<rectangle x1="2.286" y1="-0.254" x2="2.794" y2="0.254" layer="51"/>
+</package>
+</packages>
+</library>
 </libraries>
 <attributes>
 </attributes>
@@ -2383,6 +2428,13 @@ Please make sure your boards conform to these design rules.</description>
 <element name="R1" library="resistor" package="R0603" value="50k" x="14.097" y="39.37" rot="MR180"/>
 <element name="C22" library="rcl" package="CT6032" value="220uf" x="55.118" y="76.073" rot="R270"/>
 <element name="C23" library="rcl" package="CT6032" value="220uf" x="16.256" y="53.721"/>
+<element name="SV2" library="con-lstb" package="MA03-1" value="" x="96.774" y="8.255" smashed="yes" rot="R90">
+<attribute name="OC_NEWARK" value="unknown" x="96.774" y="8.255" size="1.778" layer="27" rot="R90" display="off"/>
+<attribute name="MPN" value="" x="96.774" y="8.255" size="1.778" layer="27" rot="R90" display="off"/>
+<attribute name="MF" value="" x="96.774" y="8.255" size="1.778" layer="27" rot="R90" display="off"/>
+<attribute name="OC_FARNELL" value="unknown" x="96.774" y="8.255" size="1.778" layer="27" rot="R90" display="off"/>
+<attribute name="VALUE" x="99.695" y="4.445" size="1.27" layer="27" ratio="10" rot="R90"/>
+</element>
 </elements>
 <signals>
 <signal name="GND">
@@ -3308,6 +3360,9 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="112.903" y1="68.58" x2="112.903" y2="67.056" width="0.2032" layer="1"/>
 <wire x1="112.903" y1="67.056" x2="112.395" y2="66.548" width="0.2032" layer="1"/>
 <wire x1="112.395" y1="66.548" x2="111.0742" y2="66.548" width="0.2032" layer="1"/>
+<contactref element="SV2" pad="1"/>
+<wire x1="93.853" y1="6.35" x2="96.139" y2="6.35" width="0.2032" layer="1"/>
+<wire x1="96.139" y1="6.35" x2="96.774" y2="5.715" width="0.2032" layer="1"/>
 </signal>
 <signal name="!PWR_KILL">
 <contactref element="U$16" pad="GPIO127_TS_IRQ"/>
@@ -4954,7 +5009,6 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="83.148" y1="18.669" x2="83.192" y2="18.713" width="0.2032" layer="16"/>
 <wire x1="83.192" y1="18.713" x2="83.236" y2="18.669" width="0.2032" layer="16"/>
 <wire x1="85.471" y1="18.669" x2="83.148" y2="18.669" width="0.2032" layer="16"/>
-<wire x1="85.598" y1="18.542" x2="85.471" y2="18.669" width="0.2032" layer="16"/>
 <wire x1="68.832" y1="28.743" x2="71.206" y2="28.743" width="0.2032" layer="16"/>
 <wire x1="71.206" y1="28.743" x2="71.628" y2="28.321" width="0.2032" layer="16"/>
 <wire x1="71.628" y1="28.321" x2="72.39" y2="27.559" width="0.2032" layer="1"/>
@@ -4968,13 +5022,24 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="87.757" y1="30.226" x2="87.757" y2="25.781" width="0.2032" layer="16"/>
 <wire x1="87.757" y1="25.781" x2="87.503" y2="25.527" width="0.2032" layer="16"/>
 <wire x1="87.503" y1="25.527" x2="87.503" y2="24.892" width="0.2032" layer="1"/>
-<wire x1="86.233" y1="19.177" x2="85.598" y2="18.542" width="0.2032" layer="1"/>
 <wire x1="86.233" y1="23.622" x2="86.233" y2="19.177" width="0.2032" layer="1"/>
 <wire x1="87.503" y1="24.892" x2="86.233" y2="23.622" width="0.2032" layer="1"/>
-<via x="85.598" y="18.542" extent="1-16" drill="0.381"/>
 <via x="71.628" y="28.321" extent="1-16" drill="0.381"/>
 <via x="87.757" y="30.226" extent="1-16" drill="0.381"/>
 <via x="87.503" y="25.527" extent="1-16" drill="0.381"/>
+<via x="85.471" y="18.669" extent="1-16" drill="0.381"/>
+<wire x1="85.471" y1="18.669" x2="85.725" y2="18.669" width="0.2032" layer="1"/>
+<wire x1="85.725" y1="18.669" x2="86.233" y2="19.177" width="0.2032" layer="1"/>
+<contactref element="SV2" pad="3"/>
+<wire x1="96.774" y1="10.795" x2="96.774" y2="15.621" width="0.2032" layer="16"/>
+<wire x1="96.774" y1="15.621" x2="95.885" y2="16.51" width="0.2032" layer="16"/>
+<wire x1="95.885" y1="16.51" x2="90.297" y2="16.51" width="0.2032" layer="16"/>
+<wire x1="90.297" y1="16.51" x2="89.662" y2="17.145" width="0.2032" layer="16"/>
+<wire x1="89.662" y1="17.145" x2="89.535" y2="17.145" width="0.2032" layer="16"/>
+<wire x1="89.535" y1="17.145" x2="88.773" y2="17.907" width="0.2032" layer="16"/>
+<wire x1="88.773" y1="17.907" x2="87.63" y2="17.907" width="0.2032" layer="16"/>
+<wire x1="87.63" y1="17.907" x2="86.868" y2="18.669" width="0.2032" layer="16"/>
+<wire x1="86.868" y1="18.669" x2="85.471" y2="18.669" width="0.2032" layer="16"/>
 </signal>
 <signal name="AVR_UART_TX_3.3V">
 <contactref element="U1" pad="47"/>
@@ -4992,16 +5057,25 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="88.519" y1="29.972" x2="88.519" y2="26.035" width="0.2032" layer="16"/>
 <wire x1="84.784" y1="18.213" x2="83.192" y2="18.213" width="0.2032" layer="16"/>
 <wire x1="85.344" y1="17.653" x2="84.784" y2="18.213" width="0.2032" layer="16"/>
-<wire x1="86.487" y1="17.653" x2="85.344" y2="17.653" width="0.2032" layer="16"/>
-<wire x1="86.868" y1="18.034" x2="86.487" y2="17.653" width="0.2032" layer="16"/>
 <wire x1="88.519" y1="26.035" x2="88.519" y2="25.273" width="0.2032" layer="1"/>
 <wire x1="88.519" y1="25.273" x2="86.614" y2="23.368" width="0.2032" layer="1"/>
-<wire x1="86.614" y1="23.368" x2="86.614" y2="18.288" width="0.2032" layer="1"/>
-<wire x1="86.614" y1="18.288" x2="86.868" y2="18.034" width="0.2032" layer="1"/>
-<via x="86.868" y="18.034" extent="1-16" drill="0.381"/>
 <via x="72.771" y="28.321" extent="1-16" drill="0.381"/>
 <via x="88.646" y="30.988" extent="1-16" drill="0.381"/>
 <via x="88.519" y="26.035" extent="1-16" drill="0.381"/>
+<wire x1="86.614" y1="23.368" x2="86.614" y2="17.653" width="0.2032" layer="1"/>
+<wire x1="85.344" y1="17.653" x2="86.614" y2="17.653" width="0.2032" layer="16"/>
+<via x="86.614" y="17.653" extent="1-16" drill="0.381"/>
+<contactref element="SV2" pad="2"/>
+<wire x1="86.614" y1="17.653" x2="87.249" y2="17.653" width="0.2032" layer="16"/>
+<wire x1="87.249" y1="17.653" x2="87.63" y2="17.272" width="0.2032" layer="16"/>
+<wire x1="87.63" y1="17.272" x2="88.9" y2="17.272" width="0.2032" layer="16"/>
+<wire x1="88.9" y1="17.272" x2="89.535" y2="16.637" width="0.2032" layer="16"/>
+<wire x1="89.535" y1="16.637" x2="89.662" y2="16.637" width="0.2032" layer="16"/>
+<wire x1="89.662" y1="16.637" x2="90.551" y2="15.748" width="0.2032" layer="16"/>
+<wire x1="90.551" y1="15.748" x2="94.107" y2="15.748" width="0.2032" layer="16"/>
+<wire x1="94.107" y1="15.748" x2="94.996" y2="14.605" width="0.2032" layer="16"/>
+<wire x1="94.996" y1="14.605" x2="94.996" y2="9.779" width="0.2032" layer="16"/>
+<wire x1="94.996" y1="9.779" x2="96.774" y2="8.255" width="0.2032" layer="16"/>
 </signal>
 <signal name="GYRO_PD">
 <contactref element="U1" pad="29"/>
@@ -5334,7 +5408,7 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="85.664" y1="15.9151" x2="86.6541" y2="15.9151" width="0.2032" layer="1"/>
 <wire x1="86.6541" y1="15.9151" x2="86.868" y2="16.129" width="0.2032" layer="1"/>
 <wire x1="86.868" y1="16.129" x2="86.868" y2="16.891" width="0.2032" layer="1"/>
-<wire x1="87.503" y1="17.526" x2="88.138" y2="17.526" width="0.2032" layer="1"/>
+<wire x1="87.503" y1="17.526" x2="90.551" y2="17.526" width="0.2032" layer="1"/>
 <wire x1="86.868" y1="16.891" x2="87.503" y2="17.526" width="0.2032" layer="1"/>
 <wire x1="83.192" y1="24.713" x2="83.641" y2="24.713" width="0.254" layer="16"/>
 <wire x1="83.641" y1="24.713" x2="84.328" y2="25.4" width="0.254" layer="16"/>
@@ -5498,7 +5572,7 @@ Please make sure your boards conform to these design rules.</description>
 <via x="80.137" y="14.986" extent="1-16" drill="0.381"/>
 <via x="87.884" y="73.025" extent="1-16" drill="0.381"/>
 <via x="97.028" y="72.771" extent="1-16" drill="0.381"/>
-<via x="88.138" y="17.526" extent="1-16" drill="0.381"/>
+<via x="90.551" y="17.526" extent="1-16" drill="0.381"/>
 <via x="84.328" y="26.162" extent="1-16" drill="0.381"/>
 <via x="100.711" y="59.436" extent="1-16" drill="0.381"/>
 <via x="99.314" y="53.721" extent="1-16" drill="0.381"/>
@@ -7849,7 +7923,6 @@ Please make sure your boards conform to these design rules.</description>
 <contactref element="U$29" pad="5"/>
 <contactref element="R43" pad="2"/>
 <contactref element="U12" pad="6"/>
-<wire x1="90.043" y1="14.986" x2="90.043" y2="16.637" width="0.2032" layer="1"/>
 <wire x1="90.043" y1="10.414" x2="90.043" y2="14.986" width="0.2032" layer="16"/>
 <wire x1="89.662" y1="10.033" x2="90.043" y2="10.414" width="0.2032" layer="16"/>
 <wire x1="82.804" y1="10.033" x2="89.662" y2="10.033" width="0.2032" layer="16"/>
@@ -7867,7 +7940,6 @@ Please make sure your boards conform to these design rules.</description>
 <wire x1="87.376" y1="23.622" x2="89.662" y2="23.622" width="0.2032" layer="1"/>
 <wire x1="86.995" y1="23.241" x2="87.376" y2="23.622" width="0.2032" layer="1"/>
 <wire x1="86.995" y1="19.685" x2="86.995" y2="23.241" width="0.2032" layer="1"/>
-<wire x1="90.043" y1="16.637" x2="86.995" y2="19.685" width="0.2032" layer="1"/>
 <wire x1="69.596" y1="12.065" x2="69.596" y2="22.098" width="0.2032" layer="16"/>
 <wire x1="69.596" y1="22.098" x2="69.596" y2="22.137" width="0.2032" layer="1"/>
 <wire x1="69.596" y1="22.137" x2="67.945" y2="23.788" width="0.2032" layer="1"/>
@@ -7879,6 +7951,15 @@ Please make sure your boards conform to these design rules.</description>
 <via x="81.788" y="9.017" extent="1-16" drill="0.381"/>
 <via x="69.596" y="12.065" extent="1-16" drill="0.381"/>
 <via x="69.596" y="22.098" extent="1-16" drill="0.381"/>
+<wire x1="90.043" y1="14.986" x2="90.043" y2="16.002" width="0.2032" layer="1"/>
+<wire x1="90.043" y1="16.002" x2="90.805" y2="16.764" width="0.2032" layer="1"/>
+<wire x1="90.805" y1="16.764" x2="91.948" y2="16.764" width="0.2032" layer="1"/>
+<wire x1="91.948" y1="16.764" x2="92.329" y2="17.145" width="0.2032" layer="1"/>
+<wire x1="92.329" y1="17.145" x2="92.329" y2="18.669" width="0.2032" layer="1"/>
+<wire x1="92.329" y1="18.669" x2="91.948" y2="19.05" width="0.2032" layer="1"/>
+<wire x1="91.948" y1="19.05" x2="88.392" y2="19.05" width="0.2032" layer="1"/>
+<wire x1="88.392" y1="19.05" x2="87.757" y2="19.685" width="0.2032" layer="1"/>
+<wire x1="87.757" y1="19.685" x2="86.995" y2="19.685" width="0.2032" layer="1"/>
 </signal>
 <signal name="BOM_SIG0">
 <contactref element="U1" pad="36"/>
diff --git a/scoutfly/scoutfly_rev3.sch b/scoutfly/scoutfly_rev3.sch
index b921be7..40fc50c 100755
--- a/scoutfly/scoutfly_rev3.sch
+++ b/scoutfly/scoutfly_rev3.sch
@@ -18988,6 +18988,89 @@ Source: 3967.pdf</description>
 </deviceset>
 </devicesets>
 </library>
+<library name="con-lstb">
+<description>&lt;b&gt;Pin Headers&lt;/b&gt;&lt;p&gt;
+Naming:&lt;p&gt;
+MA = male&lt;p&gt;
+# contacts - # rows&lt;p&gt;
+W = angled&lt;p&gt;
+&lt;author&gt;Created by librarian@cadsoft.de&lt;/author&gt;</description>
+<packages>
+<package name="MA03-1">
+<description>&lt;b&gt;PIN HEADER&lt;/b&gt;</description>
+<wire x1="-3.175" y1="1.27" x2="-1.905" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="-1.905" y1="1.27" x2="-1.27" y2="0.635" width="0.1524" layer="21"/>
+<wire x1="-1.27" y1="-0.635" x2="-1.905" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="-1.27" y1="0.635" x2="-0.635" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="-0.635" y1="1.27" x2="0.635" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="0.635" y1="1.27" x2="1.27" y2="0.635" width="0.1524" layer="21"/>
+<wire x1="1.27" y1="-0.635" x2="0.635" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="0.635" y1="-1.27" x2="-0.635" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="-0.635" y1="-1.27" x2="-1.27" y2="-0.635" width="0.1524" layer="21"/>
+<wire x1="-3.81" y1="0.635" x2="-3.81" y2="-0.635" width="0.1524" layer="21"/>
+<wire x1="-3.175" y1="1.27" x2="-3.81" y2="0.635" width="0.1524" layer="21"/>
+<wire x1="-3.81" y1="-0.635" x2="-3.175" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="-1.905" y1="-1.27" x2="-3.175" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="1.27" y1="0.635" x2="1.905" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="1.905" y1="1.27" x2="3.175" y2="1.27" width="0.1524" layer="21"/>
+<wire x1="3.175" y1="1.27" x2="3.81" y2="0.635" width="0.1524" layer="21"/>
+<wire x1="3.81" y1="-0.635" x2="3.175" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="3.175" y1="-1.27" x2="1.905" y2="-1.27" width="0.1524" layer="21"/>
+<wire x1="1.905" y1="-1.27" x2="1.27" y2="-0.635" width="0.1524" layer="21"/>
+<wire x1="3.81" y1="0.635" x2="3.81" y2="-0.635" width="0.1524" layer="21"/>
+<pad name="1" x="-2.54" y="0" drill="1.016" shape="long" rot="R90"/>
+<pad name="2" x="0" y="0" drill="1.016" shape="long" rot="R90"/>
+<pad name="3" x="2.54" y="0" drill="1.016" shape="long" rot="R90"/>
+<text x="-3.81" y="1.651" size="1.27" layer="25" ratio="10">&gt;NAME</text>
+<text x="-5.08" y="-0.635" size="1.27" layer="21" ratio="10">1</text>
+<text x="-3.81" y="-2.921" size="1.27" layer="27" ratio="10">&gt;VALUE</text>
+<rectangle x1="-0.254" y1="-0.254" x2="0.254" y2="0.254" layer="51"/>
+<rectangle x1="-2.794" y1="-0.254" x2="-2.286" y2="0.254" layer="51"/>
+<rectangle x1="2.286" y1="-0.254" x2="2.794" y2="0.254" layer="51"/>
+</package>
+</packages>
+<symbols>
+<symbol name="MA03-1">
+<wire x1="3.81" y1="-5.08" x2="-1.27" y2="-5.08" width="0.4064" layer="94"/>
+<wire x1="1.27" y1="2.54" x2="2.54" y2="2.54" width="0.6096" layer="94"/>
+<wire x1="1.27" y1="0" x2="2.54" y2="0" width="0.6096" layer="94"/>
+<wire x1="1.27" y1="-2.54" x2="2.54" y2="-2.54" width="0.6096" layer="94"/>
+<wire x1="-1.27" y1="5.08" x2="-1.27" y2="-5.08" width="0.4064" layer="94"/>
+<wire x1="3.81" y1="-5.08" x2="3.81" y2="5.08" width="0.4064" layer="94"/>
+<wire x1="-1.27" y1="5.08" x2="3.81" y2="5.08" width="0.4064" layer="94"/>
+<text x="-1.27" y="-7.62" size="1.778" layer="96">&gt;VALUE</text>
+<text x="-1.27" y="5.842" size="1.778" layer="95">&gt;NAME</text>
+<pin name="1" x="7.62" y="-2.54" visible="pad" length="middle" direction="pas" swaplevel="1" rot="R180"/>
+<pin name="2" x="7.62" y="0" visible="pad" length="middle" direction="pas" swaplevel="1" rot="R180"/>
+<pin name="3" x="7.62" y="2.54" visible="pad" length="middle" direction="pas" swaplevel="1" rot="R180"/>
+</symbol>
+</symbols>
+<devicesets>
+<deviceset name="MA03-1" prefix="SV" uservalue="yes">
+<description>&lt;b&gt;PIN HEADER&lt;/b&gt;</description>
+<gates>
+<gate name="G$1" symbol="MA03-1" x="0" y="0"/>
+</gates>
+<devices>
+<device name="" package="MA03-1">
+<connects>
+<connect gate="G$1" pin="1" pad="1"/>
+<connect gate="G$1" pin="2" pad="2"/>
+<connect gate="G$1" pin="3" pad="3"/>
+</connects>
+<technologies>
+<technology name="">
+<attribute name="MF" value="" constant="no"/>
+<attribute name="MPN" value="" constant="no"/>
+<attribute name="OC_FARNELL" value="unknown" constant="no"/>
+<attribute name="OC_NEWARK" value="unknown" constant="no"/>
+</technology>
+</technologies>
+</device>
+</devices>
+</deviceset>
+</devicesets>
+</library>
 </libraries>
 <attributes>
 </attributes>
@@ -19361,6 +19444,8 @@ Source: 3967.pdf</description>
 <part name="P+12" library="supply1" deviceset="VCC" device=""/>
 <part name="GND15" library="supply1" deviceset="GND" device=""/>
 <part name="+3V33" library="supply1" deviceset="+3V3" device=""/>
+<part name="SV2" library="con-lstb" deviceset="MA03-1" device=""/>
+<part name="GND16" library="supply1" deviceset="GND" device=""/>
 </parts>
 <sheets>
 <sheet>
@@ -19833,6 +19918,8 @@ Source: 3967.pdf</description>
 <instance part="P+12" gate="VCC" x="-510.54" y="106.68"/>
 <instance part="GND15" gate="1" x="81.28" y="-195.58"/>
 <instance part="+3V33" gate="G$1" x="-464.82" y="175.26"/>
+<instance part="SV2" gate="G$1" x="449.58" y="-342.9" rot="R180"/>
+<instance part="GND16" gate="1" x="431.8" y="-335.28" rot="R180"/>
 </instances>
 <busses>
 </busses>
@@ -20584,6 +20671,12 @@ Source: 3967.pdf</description>
 <wire x1="83.82" y1="-190.5" x2="81.28" y2="-190.5" width="0.1524" layer="91"/>
 <wire x1="81.28" y1="-190.5" x2="81.28" y2="-193.04" width="0.1524" layer="91"/>
 </segment>
+<segment>
+<pinref part="SV2" gate="G$1" pin="1"/>
+<wire x1="441.96" y1="-340.36" x2="431.8" y2="-340.36" width="0.1524" layer="91"/>
+<wire x1="431.8" y1="-340.36" x2="431.8" y2="-337.82" width="0.1524" layer="91"/>
+<pinref part="GND16" gate="1" pin="GND"/>
+</segment>
 </net>
 <net name="!PWR_KILL" class="0">
 <segment>
@@ -21606,6 +21699,11 @@ Source: 3967.pdf</description>
 <label x="-111.76" y="-170.18" size="1.778" layer="95" rot="R90"/>
 <pinref part="U11" gate="G$3" pin="B"/>
 </segment>
+<segment>
+<pinref part="SV2" gate="G$1" pin="3"/>
+<wire x1="441.96" y1="-345.44" x2="431.8" y2="-345.44" width="0.1524" layer="91"/>
+<label x="416.56" y="-345.44" size="1.778" layer="95"/>
+</segment>
 </net>
 <net name="AVR_UART_TX_3.3V" class="0">
 <segment>
@@ -21618,6 +21716,11 @@ Source: 3967.pdf</description>
 <label x="-104.14" y="-170.18" size="1.778" layer="95" rot="R90"/>
 <pinref part="U11" gate="G$2" pin="B"/>
 </segment>
+<segment>
+<pinref part="SV2" gate="G$1" pin="2"/>
+<wire x1="441.96" y1="-342.9" x2="431.8" y2="-342.9" width="0.1524" layer="91"/>
+<label x="416.56" y="-342.9" size="1.778" layer="95"/>
+</segment>
 </net>
 <net name="GYRO_PD" class="0">
 <segment>